<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2020 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo
 * Release Date: 2019-01-08
 */
define('IN_DOUCO', true);

$_CUR = 'comment';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// 开启SESSION
session_start();

// rec操作项的初始化
$rec = $check->is_rec($_GET['rec']) ? $_GET['rec'] : 'default';

/**
 * +----------------------------------------------------------
 * 评论提交
 * +----------------------------------------------------------
 */
if ($rec == 'insert') {
    // 数据验证
    $captcha = $check->is_captcha($_POST['captcha']) ? strtoupper($_POST['captcha']) : '';
    $module = $check->is_extend_id($_POST['module']) ? $_POST['module'] : '';
    $item_id = $check->is_number($_POST['item_id']) ? $_POST['item_id'] : '';

    // 如果限制必须输入中文则修改错误提示
    $include_chinese = $_CFG['input_must_include_chinese'] ? $_LANG['input_must_include_chinese'] : '';
 
    // 验证评论内容
    if ($check->is_illegal_char($_POST['content'])) {
        $wrong['content'] = $_LANG['comment_content'] . $_LANG['illegal_char'];
    } elseif (!check_comment($_POST['content'], 300)) {
        $wrong['content'] = preg_replace('/d%/Ums', $include_chinese, $_LANG['comment_content_wrong']);
    }
    
    // 判断验证码
    if ($_CFG['captcha'] && md5($captcha . DOU_SHELL) != $_SESSION['captcha'])
        $wrong['captcha'] = $_LANG['captcha_wrong'];

    // 判断是否需要登录会员才能评论
    if ($_PARAM['comment_need_login']) {
        if (!is_array($_GLOBAL_USER)) {
            $wrong = array();
            $wrong['comment_need_login'] = $_LANG['comment_comment_need_login'];
        }
    }

    // AJAX验证表单
    if ($_REQUEST['do'] == 'callback') {
        if ($wrong) {
            foreach ($_POST as $key => $value) {
                $wrong_json[$key] = $wrong[$key];
            }
            echo json_encode($wrong_json);
        } else {
            echo json_encode('');
        }
        exit;
    }

    // 初始化数据
    $ip = $dou->get_ip();
    $add_time = time();
 
    // 检查IP是否频繁评论
    if (is_water($ip))
        $dou->dou_msg($_LANG['comment_is_water'], $_SERVER['HTTP_REFERER']);

    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $wrong_format .= $wrong[$key] . '<br>';
        }
        $dou->dou_msg($wrong_format, $_SERVER['HTTP_REFERER']);
    }

    // 安全处理用户输入信息
    $_POST = $firewall->dou_foreground($_POST);
 
    // 会员信息
    if ($_GLOBAL_USER) {
        $user_id = $_GLOBAL_USER['user_id'];
        $nickname = $dou->get_one("SELECT nickname FROM " . $dou->table('user') . " WHERE user_id = '$user_id'");
    } else {
        $user_id = 0;
    }
    $nickname = $nickname ? $nickname : $_LANG['comment_anonymous'];
    
    if ($module && $item_id) {
        $sql = "INSERT INTO " . $dou->table('comment') . " (id, user_id, module, item_id, nickname, content, ip, add_time)" . " VALUES (NULL, '$user_id', '$module', '$item_id', '$nickname', '$_POST[content]', '$ip', '$add_time')";
        $dou->query($sql);
    }

    $dou->dou_msg($_LANG['comment_success'], $_SERVER['HTTP_REFERER']);
}

/**
 * +----------------------------------------------------------
 * 防灌水
 * +----------------------------------------------------------
 */
function is_water($ip) {
    $unread_messages = $GLOBALS['dou']->get_one("SELECT COUNT(*) FROM " . $GLOBALS['dou']->table('comment') . " WHERE ip = '$ip' AND if_read = 0 AND reply_id = 0");
    
    // 如果管理员未回复的评论数量大于1
    if ($unread_messages >= '1')
        return true;
}

/**
 * +----------------------------------------------------------
 * 检查是否包含中文字符且长度符合要求
 * +----------------------------------------------------------
 */
function check_comment($value, $length) {
    $check_chinese = $GLOBALS['_CFG']['input_must_include_chinese'] ? $GLOBALS['check']->if_include_chinese($value) : true;
    
    if ($check_chinese && $GLOBALS['check']->ch_length($value, $length)) {
        return true;
    }
}
?>